## org.apache.batik.dom
Class ExtensibleDOMImplementation

    java.lang.Object
      org.apache.batik.dom.AbstractDOMImplementation
          org.apache.batik.dom.ExtensibleDOMImplementation

All Implemented Interfaces:
  java.io.Serializable, StyleSheetFactory, Localizable, org.w3c.dom.css.DOMImplementationCSS, org.w3c.dom.DOMImplementation

Direct Known Subclasses:
  SVGDOMImplementation

    public abstract class ExtensibleDOMImplementation

extends AbstractDOMImplementation
implements org.w3c.dom.css.DOMImplementationCSS, StyleSheetFactory, Localizable

This class implements the `DOMImplementation` interface. It allows the user to extend the set of elements supported by a Document, directly or through the Service API (see `Service`).

See Also:
  Serialized Form

Nested Class Summary
`static interface` `ExtensibleDOMImplementation.ElementFactory` This interface represents a factory for elements.

Field Summary
`protected DoublyIndexedTable` `customFactories` The custom elements factories.
`protected java.util.List` `customShorthandManagers` The custom shorthand value managers.
`protected java.util.List` `customValueManagers` The custom value managers.
`protected static java.util.List` `extensions`
`protected LocalizableSupport` `localizableSupport` The localizable support for the error messages.
`protected static java.lang.String` `RESOURCES` The error messages bundle class name.

Fields inherited from class org.apache.batik.dom.AbstractDOMImplementation
`features`

Constructor Summary
`ExtensibleDOMImplementation()` Creates a new DOMImplementation.

Method Summary
`CSSEngine` `createCSSEngine(AbstractStylableDocument doc, CSSContext ctx)` Creates new CSSEngine and attach it to the document.
`abstract CSSEngine` `createCSSEngine(AbstractStylableDocument doc, CSSContext ctx, ExtendedParser ep, ValueManager[] vms, ShorthandManager[] sms)`
`org.w3c.dom.Element` `createElementNS(AbstractDocument document, java.lang.String namespaceURI, java.lang.String qualifiedName)` Implements the behavior of Document.createElementNS() for this DOM implementation.
`abstract org.w3c.dom.css.ViewCSS` `createViewCSS(AbstractStylableDocument doc)` Creates a ViewCSS.
`java.lang.String` `formatMessage(java.lang.String key, java.lang.Object[] args)` Implements `Localizable.formatMessage(String,Object[])`.
`protected static java.util.List` `getDomExtensions()`
`java.util.Locale` `getLocale()` Implements `Localizable.getLocale()`.
`protected void` `initLocalizable()`
`void` `registerCustomCSSShorthandManager(ShorthandManager sm)` Allows the user to register a new shorthand CSS value manager.
`void` `registerCustomCSSValueManager(ValueManager vm)` Allows the user to register a new CSS value manager.
`void` `registerCustomElementFactory(java.lang.String namespaceURI, java.lang.String localName, ExtensibleDOMImplementation.ElementFactory factory)` Allows the user to register a new element factory.
`void` `setLocale(java.util.Locale l)` Implements `Localizable.setLocale(Locale)`.

Methods inherited from class org.apache.batik.dom.AbstractDOMImplementation
`createDocumentEventSupport, createEventSupport, getFeature, hasFeature, registerFeature`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.w3c.dom.css.DOMImplementationCSS
`createCSSStyleSheet`

Methods inherited from interface org.w3c.dom.DOMImplementation
`createDocument, createDocumentType, getFeature, hasFeature`

Methods inherited from interface org.apache.batik.dom.StyleSheetFactory
`createStyleSheet`

Field Detail

### customFactories

    protected DoublyIndexedTable customFactories

  The custom elements factories.

### customValueManagers

    protected java.util.List customValueManagers

  The custom value managers.

### customShorthandManagers

    protected java.util.List customShorthandManagers

  The custom shorthand value managers.

### RESOURCES

    protected static final java.lang.String RESOURCES

  The error messages bundle class name.

  See Also:
    Constant Field Values

### localizableSupport

    protected LocalizableSupport localizableSupport

  The localizable support for the error messages.

### extensions

    protected static java.util.List extensions

Constructor Detail

### ExtensibleDOMImplementation

    public ExtensibleDOMImplementation()

  Creates a new DOMImplementation.

Method Detail

### setLocale

    public void setLocale(java.util.Locale l)

  Implements `Localizable.setLocale(Locale)`.

  Specified by:
    `setLocale` in interface `Localizable`
  Parameters:
    `l` - The locale to set.

### getLocale

    public java.util.Locale getLocale()

  Implements `Localizable.getLocale()`.

  Specified by:
    `getLocale` in interface `Localizable`

### initLocalizable

    protected void initLocalizable()

### formatMessage

    public java.lang.String formatMessage(java.lang.String key,
                                          java.lang.Object[] args)
                                   throws java.util.MissingResourceException

  Implements `Localizable.formatMessage(String,Object[])`.

  Specified by:
    `formatMessage` in interface `Localizable`
  Parameters:
    `key` - The key used to retreive the message from the resource bundle.
    `args` - The objects that compose the message.
  Throws:
    `java.util.MissingResourceException` - if the key is not in the bundle.

### registerCustomElementFactory

    public void registerCustomElementFactory(java.lang.String namespaceURI,
                                             java.lang.String localName,
                                             ExtensibleDOMImplementation.ElementFactory factory)

  Allows the user to register a new element factory.

### registerCustomCSSValueManager

    public void registerCustomCSSValueManager(ValueManager vm)

  Allows the user to register a new CSS value manager.

### registerCustomCSSShorthandManager

    public void registerCustomCSSShorthandManager(ShorthandManager sm)

  Allows the user to register a new shorthand CSS value manager.

### createCSSEngine

    public CSSEngine createCSSEngine(AbstractStylableDocument doc,
                                     CSSContext ctx)

  Creates new CSSEngine and attach it to the document.

### createCSSEngine

    public abstract CSSEngine createCSSEngine(AbstractStylableDocument doc,
                                              CSSContext ctx,
                                              ExtendedParser ep,
                                              ValueManager[] vms,
                                              ShorthandManager[] sms)

### createViewCSS

    public abstract org.w3c.dom.css.ViewCSS createViewCSS(AbstractStylableDocument doc)

  Creates a ViewCSS.

### createElementNS

    public org.w3c.dom.Element createElementNS(AbstractDocument document,
                                               java.lang.String namespaceURI,
                                               java.lang.String qualifiedName)

  Implements the behavior of Document.createElementNS() for this DOM implementation.

### getDomExtensions

    protected static java.util.List getDomExtensions()

Copyright © 2008 Apache Software Foundation. All Rights Reserved.